<template>
  <div>
    <v-card outlined class="panel">
      <v-card-title>
        Grupet
        <v-spacer />
        <f-action-btn icon="mdi-plus" @click="createClientModal = true" />
      </v-card-title>
      <v-card-subtitle class="pt-0">
        <search-input v-model="filter" />
      </v-card-subtitle>
      <liquor-tree
        v-if="loaded"
        :data="treeData"
        :filter="filter"
        :options="treeOptions"
        @node:selected="onNodeSelected"
      >
        <div slot-scope="{ node }" class="node-container">
          <div class="node-text">
            {{ node.text }}
          </div>
          <div class="node-controls">
            <f-action-btn
              icon="mdi-plus"
              @click="createSubClientModal = true"
            />
            <f-action-btn icon="mdi-pencil" @click="editClientModal = true" />
            <f-action-btn icon="mdi-minus" @click="deleteClientModal = true" />
          </div>
        </div>
      </liquor-tree>
    </v-card>
    <create-client-group v-model="createClientModal" />
    <create-client-sub-group
      v-model="createSubClientModal"
      :client-group="treeNode"
    />
    <edit-client-group
      v-model="editClientModal"
      :client-group="treeNode"
      :label="selectedValue"
    />
    <delete-client-group v-model="deleteClientModal" :client-group="treeNode" />
  </div>
</template>
<script lang="ts">
import { Vue, Component } from 'vue-property-decorator'
import LiquorTree from 'liquor-tree'
import eventBus from '../../../../plugins/event-bus'
import FActionBtn from '../../../../components/buttons/FActionBtn.vue'
import SearchInput from '../../../../components/inputs/SearchInput.vue'
import CreateClientGroup from './CreateClientGroup.vue'
import CreateClientSubGroup from './CreateClientSubGroup.vue'
import EditClientGroup from './EditClientGroup.vue'
import api from '@/plugins/api'
import DeleteClientGroup from './DeleteClientGroup.vue'

@Component({
  components: {
    LiquorTree,
    FActionBtn,
    SearchInput,
    CreateClientGroup,
    CreateClientSubGroup,
    EditClientGroup,
    DeleteClientGroup,
  },
})
export default class ClientGroup extends Vue {
  message = ''
  show = false
  color = ''
  loaded = false
  filter = ''
  treeData = []
  treeNode = {}
  selectedValue = null
  createClientModal = false
  createSubClientModal = false
  editClientModal = false
  deleteClientModal = false
  treeOptions = {
    filter: {
      emptyText: 'Nuk u gjet asnjë rezultat',
      matcher: (query, node) => {
        const filter = this.filter.toLowerCase()
        let name = false
        if (node.data.text) {
          name = node.data.text.toLowerCase().match(filter)
        }

        return name
      },
      plainList: true,
      showChildren: false,
    },
  }
  mounted() {
    this.fetchClientGroups()
    this.reloadClientGroups()
  }
  fetchClientGroups() {
    this.loaded = false
    api()
      .get('/api/crm/client-groups')
      .then(response => {
        this.treeData = response.data.data.map(node => ({
          children: node.children,
          id: node.id,
          data: {
            text: node.text,
            price_list_type_id: node.price_list_type_id,
          },
          text: `${node.text} (Totali: ${node.total})`,
          price_list_type_id: node.price_list_type_id,
        }))
      })
      .finally(() => {
        this.loaded = true
      })
  }
  showModal($event) {
    this.show = true
    this.message = $event.message
    this.color = $event.color
  }
  onNodeSelected(node) {
    const text = node.data.text
    this.selectedValue = text.replace(/\(.*\)/, '')
    this.treeNode = node
    this.$root.$emit('nodeSelected', node.id)
  }
  reloadClientGroups() {
    eventBus.$on('refresh', () => {
      this.fetchClientGroups()
    })
  }
}
</script>
